Index: kernel/hdegree.cc
===================================================================
--- kernel/hdegree.cc	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/hdegree.cc	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -21,5 +21,5 @@
 
 int  hCo, hMu, hMu2;
-struct omBin_s* indlist_bin = omGetSpecBin(sizeof(indlist));
+omBin indlist_bin = omGetSpecBin(sizeof(indlist));
 
 /*0 implementation*/
Index: kernel/hutil.h
===================================================================
--- kernel/hutil.h	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/hutil.h	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -30,5 +30,5 @@
 #define LEN_MON (sizeof(scfmon) + sizeof(int))
 
-extern struct omBin_s* indlist_bin;
+extern omBin indlist_bin;
 
 extern scfmon hexist, hstc, hrad, hwork;
Index: kernel/p_Procs.h
===================================================================
--- kernel/p_Procs.h	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/p_Procs.h	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -17,5 +17,5 @@
 typedef poly (*p_Copy_Proc_Ptr)(poly p, const ring r);
 typedef void (*p_Delete_Proc_Ptr)(poly *p, const ring r);
-typedef poly (*p_ShallowCopyDelete_Proc_Ptr)(poly p, const ring r, omBin_s* dest_bin);
+typedef poly (*p_ShallowCopyDelete_Proc_Ptr)(poly p, const ring r, omBin dest_bin);
 typedef poly (*p_Mult_nn_Proc_Ptr)(poly p, const number n, const ring r);
 typedef poly (*pp_Mult_nn_Proc_Ptr)(poly p, const number n, const ring r);
Index: kernel/ring.cc
===================================================================
--- kernel/ring.cc	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/ring.cc	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -1536,5 +1536,5 @@
   //memset: res->firstwv=NULL;
 
-  //struct omBin_s*   PolyBin; /* Bin from where monoms are allocated */
+  //struct omBin   PolyBin; /* Bin from where monoms are allocated */
   //memset: res->PolyBin=NULL; // rComplete
   res->ch=r->ch;     /* characteristic */
Index: kernel/ring.h
===================================================================
--- kernel/ring.h	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/ring.h	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -466,4 +466,4 @@
 void rDelete(ring r);
 
-extern struct omBin_s* sip_sring_bin;
-#endif
+extern omBin sip_sring_bin;
+#endif
Index: kernel/sparsmat.cc
===================================================================
--- kernel/sparsmat.cc	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/sparsmat.cc	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -63,5 +63,5 @@
 static number smCleardenom(ideal);
 
-struct omBin_s* smprec_bin = omGetSpecBin(sizeof(smprec));
+omBin smprec_bin = omGetSpecBin(sizeof(smprec));
 
 static poly pp_Mult_Coeff_mm_DivSelect_MultDiv(poly p, int &lp, poly m,
Index: kernel/structs.h
===================================================================
--- kernel/structs.h	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/structs.h	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -11,4 +11,6 @@
 /* for memset: */
 #include <string.h>
+/* for omBin */
+#include <omalloc.h>
 #ifdef HAVE_RINGS
 #include <kernel/si_gmp.h>
@@ -354,8 +356,4 @@
 typedef struct sro_ISTemp sro_ISTemp;
 
-#ifndef OM_ALLOC_H
-struct omBin_s;
-#endif
-
 struct sro_ord
 {
@@ -519,5 +517,5 @@
   int*     firstwv;
 
-  struct omBin_s*   PolyBin; /* Bin from where monoms are allocated */
+  omBin    PolyBin; /* Bin from where monoms are allocated */
 #ifdef HAVE_RINGS
   unsigned int  ringtype;  /* cring = 0 => coefficient field, cring = 1 => coeffs from Z/2^m */
@@ -659,7 +657,7 @@
 #endif
 
-extern struct omBin_s* char_ptr_bin;
-extern struct omBin_s* sleftv_bin;
-
-#endif
-
+extern omBin char_ptr_bin;
+extern omBin sleftv_bin;
+
+#endif
+
Index: kernel/tgb_internal.h
===================================================================
--- kernel/tgb_internal.h	(revision f0f2fea8b20a86e32a25ab7e9948aca2111645da)
+++ kernel/tgb_internal.h	(revision c5e0e120f508ee9b07dab3a5e39ea7f84a4bc0f0)
@@ -239,5 +239,5 @@
   //end for F4
 #ifdef HEAD_BIN
-  struct omBin_s*   HeadBin;
+  omBin   HeadBin;
 #endif
   unsigned int reduction_steps;
